package com.sun.jmx.snmp.internal;

import com.sun.jmx.snmp.SnmpTooBigException;
import com.sun.jmx.snmp.SnmpSecurityParameters;
import com.sun.jmx.snmp.SnmpStatusException;
import com.sun.jmx.snmp.SnmpPdu;
import com.sun.jmx.snmp.SnmpParams;
import com.sun.jmx.snmp.SnmpUnknownMsgProcModelException;
import com.sun.jmx.snmp.SnmpPduFactory;

public interface SnmpMsgProcessingSubSystem extends SnmpSubSystem
{
    public abstract void setSecuritySubSystem(SnmpSecuritySubSystem p0);
    
    public abstract SnmpSecuritySubSystem getSecuritySubSystem();
    
    public abstract SnmpIncomingRequest getIncomingRequest(int p0, SnmpPduFactory p1) throws SnmpUnknownMsgProcModelException;
    
    public abstract SnmpOutgoingRequest getOutgoingRequest(int p0, SnmpPduFactory p1) throws SnmpUnknownMsgProcModelException;
    
    public abstract SnmpPdu getRequestPdu(int p0, SnmpParams p1, int p2) throws SnmpUnknownMsgProcModelException, SnmpStatusException;
    
    public abstract SnmpIncomingResponse getIncomingResponse(int p0, SnmpPduFactory p1) throws SnmpUnknownMsgProcModelException;
    
    public abstract int encode(int p0, int p1, int p2, byte p3, int p4, SnmpSecurityParameters p5, byte[] p6, byte[] p7, byte[] p8, int p9, byte[] p10) throws SnmpTooBigException, SnmpUnknownMsgProcModelException;
    
    public abstract int encodePriv(int p0, int p1, int p2, byte p3, int p4, SnmpSecurityParameters p5, byte[] p6, byte[] p7) throws SnmpTooBigException, SnmpUnknownMsgProcModelException;
    
    public abstract SnmpDecryptedPdu decode(int p0, byte[] p1) throws SnmpStatusException, SnmpUnknownMsgProcModelException;
    
    public abstract int encode(int p0, SnmpDecryptedPdu p1, byte[] p2) throws SnmpTooBigException, SnmpUnknownMsgProcModelException;
}
